
/**
 * Geht konsequent zu einem Punkt 4 Einheiten vor dem Monster.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Fallensteller extends Gespenst
{
    /**
     * Der Konstruktor legt Position, Größe und Farbe fest
     * @param x x-Koordinate des Rechtecks
     * @param y y-Koordinate des Rechtecks
     * @param rahmen das Rahmenobjekt des Spiels
     */
    Fallensteller (int x, int y, Rahmen rahmen)
    {
        super(x, y, rahmen);
        FigurErzeugen("grün");
        GrößeSetzen(rahmen.basisGröße);
    }
    
    /**
     * Berechnet den Kästchenabstand der gegebenen Koordinatenpaare
     * @return Kästchenabstand
     */
    private int AbstandGeben (int x, int y, int x2, int y2)
    {
        return (Math.abs(x - x2) + Math.abs(y - y2)) / rahmen.basisGröße;
    }
    
    /**
     * Der Jäger bewegt sich direkt auf das Monster zu
     */
    @Override protected void Bewegen()
    {
        int minAbstand = 100000;
        int xZiel = rahmen.MonsterGeben().XPositionGeben();
        int yZiel = rahmen.MonsterGeben().YPositionGeben();
        switch (rahmen.MonsterGeben().WinkelGeben())
        {
            case 0:
                xZiel = xZiel + 4 * rahmen.basisGröße;
                break;
            case 90:
                yZiel = yZiel - 4 * rahmen.basisGröße;
                break;
            case 180:
                xZiel = xZiel - 4 * rahmen.basisGröße;
                break;
            case 270:
                yZiel = yZiel + 4 * rahmen.basisGröße;
                break;
        }
        int xOpt = XPositionGeben();
        int yOpt = YPositionGeben();
        if (!rahmen.IstMauer(XPositionGeben(), YPositionGeben() - rahmen.basisGröße))
        {
            xOpt = XPositionGeben();
            yOpt = YPositionGeben() - rahmen.basisGröße;
            minAbstand = AbstandGeben(xOpt, yOpt, xZiel, yZiel);
        }
        if ((AbstandGeben(XPositionGeben(), YPositionGeben() + rahmen.basisGröße, xZiel, yZiel) < minAbstand) && (!rahmen.IstMauer(XPositionGeben(), YPositionGeben() + rahmen.basisGröße)))
        {
            xOpt = XPositionGeben();
            yOpt = YPositionGeben() + rahmen.basisGröße;
            minAbstand = AbstandGeben(xOpt, yOpt, xZiel, yZiel);
        }
        if ((AbstandGeben(XPositionGeben() + rahmen.basisGröße, YPositionGeben(), xZiel, yZiel) < minAbstand) && (!rahmen.IstMauer(XPositionGeben() + rahmen.basisGröße, YPositionGeben())))
        {
            xOpt = XPositionGeben() + rahmen.basisGröße;
            yOpt = YPositionGeben();
            minAbstand = AbstandGeben(xOpt, yOpt, xZiel, yZiel);
        }
        if ((AbstandGeben(XPositionGeben() - rahmen.basisGröße, YPositionGeben(), xZiel, yZiel) < minAbstand) && (!rahmen.IstMauer(XPositionGeben() - rahmen.basisGröße, YPositionGeben())))
        {
            xOpt = XPositionGeben() - rahmen.basisGröße;
            yOpt = YPositionGeben();
            minAbstand = AbstandGeben(xOpt, yOpt, xZiel, yZiel);
        }
        PositionSetzen(xOpt, yOpt);
    }
}
