
/**
 * Verfolgt das Monster konsequent.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Jaeger extends Gespenst
{
    
    /**
     * Der Konstruktor legt Position, Größe und Farbe fest
     * @param x x-Koordinate des Rechtecks
     * @param y y-Koordinate des Rechtecks
     * @param rahmen das Rahmenobjekt des Spiels
     */
    Jaeger (int x, int y, Rahmen rahmen)
    {
        super(x, y, rahmen);
        FigurErzeugen("rot");
        GrößeSetzen(rahmen.basisGröße);
    }
     
    /**
     * Der Jäger bewegt sich direkt auf das Monster zu
     */
    @Override protected void Bewegen()
    {
        int minAbstand = 100000;
        int xOpt = XPositionGeben();
        int yOpt = YPositionGeben();
        if (!rahmen.IstMauer(XPositionGeben(), YPositionGeben() - rahmen.basisGröße))
        {
            xOpt = XPositionGeben();
            yOpt = YPositionGeben() - rahmen.basisGröße;
            minAbstand = AbstandGeben(xOpt, yOpt);
        }
        if ((AbstandGeben(XPositionGeben(), YPositionGeben() + rahmen.basisGröße) < minAbstand) && (!rahmen.IstMauer(XPositionGeben(), YPositionGeben() + rahmen.basisGröße)))
        {
            xOpt = XPositionGeben();
            yOpt = YPositionGeben() + rahmen.basisGröße;
            minAbstand = AbstandGeben(xOpt, yOpt);
        }
        if ((AbstandGeben(XPositionGeben() + rahmen.basisGröße, YPositionGeben()) < minAbstand) && (!rahmen.IstMauer(XPositionGeben() + rahmen.basisGröße, YPositionGeben())))
        {
            xOpt = XPositionGeben() + rahmen.basisGröße;
            yOpt = YPositionGeben();
            minAbstand = AbstandGeben(xOpt, yOpt);
        }
        if ((AbstandGeben(XPositionGeben() - rahmen.basisGröße, YPositionGeben()) < minAbstand) && (!rahmen.IstMauer(XPositionGeben() - rahmen.basisGröße, YPositionGeben())))
        {
            xOpt = XPositionGeben() - rahmen.basisGröße;
            yOpt = YPositionGeben();
            minAbstand = AbstandGeben(xOpt, yOpt);
        }
        PositionSetzen(xOpt, yOpt);
    }
}
