
import java.util.Random;
/**
 * Rechteck mit Zusatzfunktion für die Animation
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class ShowRechteck extends Rechteck implements AnimationsElement
{
    /** Zufallsgenerator */
    private Random zufall;
    /** Die zur Verfügung stehenden Farben */
    private String [] farben = {"rot", "gelb", "grün", "blau", "cyan", "magenta"};
    
    /**
     * Legt das Rechteck am gegebenen Ort an.
     * @param x x-Koordinate
     * @param y y-Koordinate
     */
    ShowRechteck(int x, int y)
    {
        super();
        zufall = new Random();
        GrößeSetzen(40 + zufall.nextInt(20), 20 + zufall.nextInt(10));
        PositionSetzen(x, y);
        FarbeSetzen(farben[zufall.nextInt(farben.length)]);
    }
    /**
     * Auftrag an das Element, sich in einer neuen Farbe dazustellen.
     */
    public void Umfärben()
    {
        FarbeSetzen(farben[zufall.nextInt(farben.length)]);
    }
    
    /**
     * Auftrag an das Element, eine kleine Bewegung auszuführen.
     */
    public void Tanzen()
    {
        Verschieben(-5 + zufall.nextInt(11), -5 + zufall.nextInt(11));
    }
}
