// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Characterraster zur Kontrolle der zeichenbaren Wege
 * @author Albert Wiedemann @version 1.0
 */
public class Raster
{
    private char[][] raster;
    private final int breite = Konstanten . breiteRaumRaster * 2 - 1;
    private final int höhe = Konstanten . höheRaumRaster * 2 - 1;
    private final char leerChar = ' ';
    private final char raumChar = '%';
    private final char wegChar = '*';

    /**
     * Legt das Raster an und besetzt es mit Leerzeichen
     */
    protected Raster()
    {
        raster = new char [ breite ] [ höhe ];
        int i = 0;
        while (i < breite) {
            int j = 0;
            while (j < höhe) {
                raster [ i ] [ j ] = leerChar;
                j = j + 1;
            }
            i = i + 1;
        }
    }

    /**
     * Meldet, ob der gegebene Rasterpunkt belegt ist @param x x-Koordinate des Rasterpunkts @param y y-Koordinate des Rasterpunkts @return wahr, wenn der Punkt frei ist
     */
    protected boolean BelegtTesten(int x, int y)
    {
        return raster [ x ] [ y ] != leerChar;
    }

    /**
     * Setzt den Rasterpunkt auf den gegebenen Wert @param x x-Koordinate des Rasterpunkts @param y y-Koordinate des Rasterpunkts @param was der neue Wert
     */
    protected void Setzen(int x, int y, char was)
    {
        raster [ x ] [ y ] = was;
    }

    /**
     * Markiert den Rasterpunkt als Raum @param x x-Koordinate des Raums @param y y-Koordinate des Raums
     */
    protected void RaumSetzen(int x, int y)
    {
        raster [ x * 2 ] [ y * 2 ] = raumChar;
    }

    /**
     * Meldet, ob an dem gegebene Rasterpunkt ein Raum gesetzt werden kann @param x x-Koordinate des Raums @param y y-Koordinate des Raums @return wahr, wenn der Punkt frei ist
     */
    protected boolean RaumOkTesten(int x, int y)
    {
        return ( x >= 0 ) && ( y >= 0 ) && ( x < Konstanten . breiteRaumRaster ) && ( y < Konstanten . höheRaumRaster ) && ( raster [ x * 2 ] [ y * 2 ] == leerChar );
    }

    /**
     * Meldet, zwischen den gegebenen Raumkoordinaten ein Weg gezeichnet werden kann @param x1 x-Koordinate des ersten Rasterpunkts @param y1 y-Koordinate des ersten Rasterpunkts @param x2 x-Koordinate des zweiten Rasterpunkts @param y2 y-Koordinate des zweiten Rasterpunkts @return wahr, wenn der Weg frei ist
     */
    protected boolean WegTesten(int x1, int y1, int x2, int y2)
    {
        x1 = x1 * 2;
        x2 = x2 * 2;
        y1 = y1 * 2;
        y2 = y2 * 2;
        while (( x1 != x2 ) || ( y1 != y2 )) {
            if (x1 > x2) {
                x1 = x1 - 1;
                x2 = x2 + 1;
            }
            else if (x1 < x2) {
                x2 = x2 - 1;
                x1 = x1 + 1;
            }
            if (y1 > y2) {
                y1 = y1 - 1;
                y2 = y2 + 1;
            }
            else if (y1 < y2) {
                y2 = y2 - 1;
                y1 = y1 + 1;
            }
            if (BelegtTesten ( x1 , y1 ) || BelegtTesten ( x2 , y2 )) {
                return false;
            }
        }
        return true;
    }

    /**
     * Trägt den Weg zwischen den gegebenen Raumkoordinaten ein @param x1 x-Koordinate des ersten Rasterpunkts @param y1 y-Koordinate des ersten Rasterpunkts @param x2 x-Koordinate des zweiten Rasterpunkts @param y2 y-Koordinate des zweiten Rasterpunkts
     */
    protected void WegZeichnen(int x1, int y1, int x2, int y2)
    {
        x1 = x1 * 2;
        x2 = x2 * 2;
        y1 = y1 * 2;
        y2 = y2 * 2;
        while (( x1 != x2 ) || ( y1 != y2 )) {
            if (x1 > x2) {
                x1 = x1 - 1;
                x2 = x2 + 1;
            }
            else if (x1 < x2) {
                x2 = x2 - 1;
                x1 = x1 + 1;
            }
            if (y1 > y2) {
                y1 = y1 - 1;
                y2 = y2 + 1;
            }
            else if (y1 < y2) {
                y2 = y2 - 1;
                y1 = y1 + 1;
            }
            Setzen ( x1 , y1 , wegChar );
            Setzen ( x2 , y2 , wegChar );
        }
    }

    /**
     * Gibt das Raster zu Testzwecken ins Konsolfenster aus.
     */
    protected void Ausgeben()
    {
        int j = höhe - 1;
        while (j >= 0) {
            int i = 0;
            while (i < breite) {
                System . out . print ( raster [ i ] [ j ] );
                i = i + 1;
            }
            System . out . println ( );
            j = j - 1;
        }
    }
}
