
import java.util.*;
/**
 * Verfolgt das Monster bis zu einem Abstand von 10 und bewegt sich dann zufällig.
 * 
 * @author Albert Wiedemann 
 * @version 1.0
 */
class Chaot extends Gespenst
{
    /** Der Zufallsgenerator */
    Random zufall;
    
    /**
     * Der Konstruktor legt Position, Größe und Farbe fest
     * @param x x-Koordinate des Rechtecks
     * @param y y-Koordinate des Rechtecks
     * @param rahmen das Rahmenobjekt des Spiels
     */
    Chaot (int x, int y, Rahmen rahmen)
    {
        super(x, y, rahmen);
        FigurErzeugen("blau");
        GrößeSetzen(rahmen.basisGröße);
        zufall = new Random();
    }
    
    /**
     * Der Jäger bewegt sich direkt auf das Monster zu
     */
    @Override protected void Bewegen()
    {
        int minAbstand = 100000;
        int xOpt = XPositionGeben();
        int yOpt = YPositionGeben();
        if (AbstandGeben(XPositionGeben(), YPositionGeben()) <= 10)
        {
            do
            {
                switch (zufall.nextInt(4))
                {
                    case 0:
                        xOpt = XPositionGeben() + rahmen.basisGröße;
                        yOpt = YPositionGeben();
                        break;
                    case 1:
                        xOpt = XPositionGeben() - rahmen.basisGröße;
                        yOpt = YPositionGeben();
                        break;
                    case 2:
                        xOpt = XPositionGeben();
                        yOpt = YPositionGeben() + rahmen.basisGröße;
                        break;
                    case 3:
                        xOpt = XPositionGeben();
                        yOpt = YPositionGeben() - rahmen.basisGröße;
                        break;
                }
            } while (rahmen.IstMauer(xOpt, yOpt));
        }
        else
        {
            if (!rahmen.IstMauer(XPositionGeben(), YPositionGeben() - rahmen.basisGröße))
            {
                xOpt = XPositionGeben();
                yOpt = YPositionGeben() - rahmen.basisGröße;
                minAbstand = AbstandGeben(xOpt, yOpt);
            }
            if ((AbstandGeben(XPositionGeben(), YPositionGeben() + rahmen.basisGröße) < minAbstand) && (!rahmen.IstMauer(XPositionGeben(), YPositionGeben() + rahmen.basisGröße)))
            {
                xOpt = XPositionGeben();
                yOpt = YPositionGeben() + rahmen.basisGröße;
                minAbstand = AbstandGeben(xOpt, yOpt);
            }
            if ((AbstandGeben(XPositionGeben() + rahmen.basisGröße, YPositionGeben()) < minAbstand) && (!rahmen.IstMauer(XPositionGeben() + rahmen.basisGröße, YPositionGeben())))
            {
                xOpt = XPositionGeben() + rahmen.basisGröße;
                yOpt = YPositionGeben();
                minAbstand = AbstandGeben(xOpt, yOpt);
            }
            if ((AbstandGeben(XPositionGeben() - rahmen.basisGröße, YPositionGeben()) < minAbstand) && (!rahmen.IstMauer(XPositionGeben() - rahmen.basisGröße, YPositionGeben())))
            {
                xOpt = XPositionGeben() - rahmen.basisGröße;
                yOpt = YPositionGeben();
                minAbstand = AbstandGeben(xOpt, yOpt);
            }
        }
        PositionSetzen(xOpt, yOpt);
    }
}
