
/**
 * Ein Fahrzeugsymbol
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class LKWSymbol extends FahrzeugSymbol
{
    /** Interna */
    private Rechteck aufbau;
    private Rechteck scheibe;

    /**
     * Standardkonstruktor für Objekte der Klasse FahrzeugSymbol.
     */
    LKWSymbol()
    {
        super();
        länge = 33;
        breite = 9;
        aufbau = new Rechteck();
        aufbau.PositionSetzen(0, 0);
        aufbau.GrößeSetzen(breite, länge);
        aufbau.FarbeSetzen(aktFarbe);
        scheibe = new Rechteck();
        scheibe.PositionSetzen(1, länge/6);
        scheibe.GrößeSetzen(breite - 2, länge/6);
        scheibe.FarbeSetzen("weiß");
    }

    /**
     * Setzt die Farbe des Fahrzeugsymbols.
     * @param neueFarbe die neue Farbe des Fahrzeugsymbols
     */
    @Override void FarbeSetzen(String neueFarbe)
    {
        super.FarbeSetzen(neueFarbe);
        aufbau.FarbeSetzen(aktFarbe);
    }

    /**
     * Setzt die Position des Fahrzeugsymbols.
     * Die Koordinaten bezeichnen die linke, obere Ecke des Fahrzeugsymbols.
     * @param x x-Position
     * @param y y-Position
     */
    @Override void PositionSetzen(int x, int y)
    {
        super.PositionSetzen(x, y);
        aufbau.PositionSetzen(x, y);
        scheibe.PositionSetzen(x + 1, y + länge/6);
    }

    /**
     * Entfernt das Fahrzeugsymbol aus der Anzeige
     */
    @Override void Entfernen()
    {
        aufbau.Entfernen();
        scheibe.Entfernen();
    }
}
