
/**
 * Beschreibt ein Fahrzeug.
 * 
 * @author Albert Wiedemann
 * @version 1.0
 */
class LangsamesFahrzeug extends Fahrzeug
{
    /** Beschleunigungen */
    protected double a1;
    protected double a2;

    /**
     * Erzeugt die Anzeige und setzt die Startdaten
     */
    LangsamesFahrzeug()
    {
        super();
    }
    
    /**
     * Fährt das Fahrzeug eine Sekunde nach oben.
     * @param wegmax maximaler Weg bis zum nächsten Hindernis (Ampel oder VOrgänger)
     * @param vvorg Geschwindigkeit des Vorgängerfahrzeugs bzw.der Ampel
     */
    @Override void Fahren(int wegmax, double vvorg)
    {
        double weg;
        double vneu;
        weg = 0;
        for (int i = 0; i < 10; i++)            // Maximaler Weg
        {
            if (v <= 5.5)
            {
                vneu = a1 * 0.1 + v;
            }
            else
            {
                vneu = a2 * 0.1 + v;
            }
            if (vneu > vmax)
            {
                vneu = vmax;
            }
            weg = weg + (vneu + v) / 2.0 * 0.1;
            v = vneu;
        }
        weg = weg * 5;                         // 1Px = 20cm
        if (wegmax <= 0.0)                     // Muss stehen bleiben
        {
            weg = 0.0;
            v = 0.0;
        }
        else if (weg >= wegmax)                 // Kommt zu dicht an den Vorgänger
        {
            weg = wegmax;
            if (v > vvorg)                      // und ist auch noch zu schnell
            {
                v = vvorg;
            }
        }
        else
        {
            vneu = (wegmax / 5.0 + vvorg * 1.0 - weg / 5.0) / 1.8; // Maximale Geschwindigkeit für den Restabstand zum Vorgänger
            if (vneu < v)                       // Zu schnell für den Abstand
            {
                v = vneu;
            }
        }
        PositionSetzen(x, y - (int) weg);
    }        
}
