// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.HashMap;

/**
 * Beschreibt einen Bewegungsmelder
 * @author Albert Wiedemann @version 1.0
 */
public class Bewegungsmelder extends Messgeraet
{
    /* aktueller Wert der Messung*/
    private boolean an;
    /* Erlaubte Eingaben*/
    private HashMap<String,Boolean> erlaubt;

    /**
     * Legt den Namen und den Beobachter fest. @param namensZusatz individualler Namensteil des Sensors
     */
    protected Bewegungsmelder(String namensZusatz)
    {
        super("Bewegungsmelder " + namensZusatz);
        an = false;
        erlaubt =  new HashMap < String, Boolean > ();
        erlaubt.put("an", true);
        erlaubt.put("ein", true);
        erlaubt.put("wahr", true);
        erlaubt.put("true", true);
        erlaubt.put("aus", false);
        erlaubt.put("falsch", false);
        erlaubt.put("false", false);
    }

    /**
     * Prüft, ob die Eingabe akzeptiert werden kann @param eingabe der eventuelle neue Sensorwert @return wahr, wenn die Eingabe eine korrekten Sensorwert repräsentiert
     */
    public boolean EingabePrüfen(String eingabe)
    {
        String e = eingabe.toLowerCase();
        return erlaubt.containsKey(e);
    }

    /**
     * Setzt den neuen Sensorwert @param an der neue Sensorwert
     */
    public void WertSetzen(String eingabe)
    {
        String e = eingabe.toLowerCase();
        an = erlaubt.get(e);
        MesswertÄnderungMelden(an);
        ZustandsÄnderungMelden();
    }

    /**
     * Meldet den Zustand des Sensors @return Zustand als Zeichenkette
     */
    protected String ZustandGeben()
    {
        if (an) {
            return "Bewegung";
        }
        else {
            return "Ruhe";
        }
    }
}
