// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.ArrayList;

/**
 * Verwaltung des Hauses
 * @author Albert Wiedemann @version 1.0
 */
public class Haus
{
    private HintergrundSymbol hintergrund;
    private Thermometer thermometerEsszimmer;
    private HeizkoerperSymbol heizkörperSymbolEsszimmer;
    private Heizkoerper heizkörperEsszimmer;
    private Uhr uhrHaus;
    private Windsensor windsensorHaus;
    private RollladenSymbol rollladenSymbolWohnzimmer1;
    private Rollladen rollladenWohnzimmer1;
    private RollladenSymbol rollladenSymbolWohnzimmer2;
    private Rollladen rollladenWohnzimmer2;
    private RollladenSymbol rollladenSymbolEsszimmer;
    private Rollladen rollladenEsszimmer;
    private RollladenSymbol rollladenSymbolKüche;
    private Rollladen rollladenKüche;
    private Bewegungsmelder bewegungsmelderWohnzimmer2;
    private Sonnensensor sonnensensorWohnzimmer2;
    private LampenSymbol lampenSymbolWohnzimmer2_1;
    private Lampe lampeWohnzimmer2_1;
    private LampenSymbol lampenSymbolWohnzimmer2_2;
    private Lampe lampeWohnzimmer2_2;
    private Waage waageKüche;
    private KuehlschrankSymbol kühlschrankSymbolKüche;
    private Kuehlschrank kühlschrankKüche;
    private ZimmerVerwaltung wohnzimmer1;
    private ZimmerVerwaltung wohnzimmer2;
    private ZimmerVerwaltung esszimmer;
    private ZimmerVerwaltung küche;
    private ZimmerVerwaltung haus;
    private ArrayList<Rollladen> rollläden;
    private ArrayList<ZimmerVerwaltung> zimmer;
    private Oberflaeche oberfläche;

    /**
     * Legt die Sensoren und Komponenten des Hauses an
     */
    protected Haus()
    {
        oberfläche = new Oberflaeche ( 15 );
        rollläden = new ArrayList < Rollladen > ( );
        wohnzimmer1 = new ZimmerVerwaltung ( "Wohnzimmer1" );
        wohnzimmer2 = new ZimmerVerwaltung ( "Wohnzimmer2" );
        esszimmer = new ZimmerVerwaltung ( "Esszimmer" );
        küche = new ZimmerVerwaltung ( "Küche" );
        haus = new ZimmerVerwaltung ( "Haus" );
        zimmer = new ArrayList < ZimmerVerwaltung > ( );
        zimmer . add ( haus );
        zimmer . add ( wohnzimmer1 );
        zimmer . add ( wohnzimmer2 );
        zimmer . add ( esszimmer );
        zimmer . add ( küche );
        hintergrund = new HintergrundSymbol ( );
        thermometerEsszimmer = new Thermometer ( "Esszimmer" );
        esszimmer . KomponenteEintragen ( thermometerEsszimmer );
        oberfläche . SmartKomponenteHinzufügen ( thermometerEsszimmer . NameGeben ( ) , thermometerEsszimmer . ZustandGeben ( ) , thermometerEsszimmer );
        heizkörperSymbolEsszimmer = new HeizkoerperSymbol ( 420 , 440 );
        heizkörperEsszimmer = new Heizkoerper ( "Esszimmer" , thermometerEsszimmer );
        esszimmer . KomponenteEintragen ( heizkörperEsszimmer );
        heizkörperEsszimmer . BeobachterRegistrieren ( heizkörperSymbolEsszimmer );
        oberfläche . SmartKomponenteHinzufügen ( heizkörperEsszimmer . NameGeben ( ) , heizkörperEsszimmer . ZustandGeben ( ) , heizkörperEsszimmer );
        uhrHaus = new Uhr ( "Haus" );
        haus . KomponenteEintragen ( uhrHaus );
        oberfläche . SmartKomponenteHinzufügen ( uhrHaus . NameGeben ( ) , uhrHaus . ZustandGeben ( ) , uhrHaus );
        windsensorHaus = new Windsensor ( "Haus" );
        haus . KomponenteEintragen ( windsensorHaus );
        oberfläche . SmartKomponenteHinzufügen ( windsensorHaus . NameGeben ( ) , windsensorHaus . ZustandGeben ( ) , windsensorHaus );
        rollladenSymbolWohnzimmer1 = new RollladenSymbol ( 250 , 125 );
        rollladenWohnzimmer1 = new Rollladen ( "Wohnzimmer1" , windsensorHaus , uhrHaus );
        rollläden . add ( rollladenWohnzimmer1 );
        rollladenWohnzimmer1 . BeobachterRegistrieren ( rollladenSymbolWohnzimmer1 );
        oberfläche . SmartKomponenteHinzufügen ( rollladenWohnzimmer1 . NameGeben ( ) , rollladenWohnzimmer1 . ZustandGeben ( ) , rollladenWohnzimmer1 );
        wohnzimmer1 . KomponenteEintragen ( rollladenWohnzimmer1 );
        rollladenSymbolWohnzimmer2 = new RollladenSymbol ( 500 , 125 );
        rollladenWohnzimmer2 = new Rollladen ( "Wohnzimmer2" , windsensorHaus , uhrHaus );
        rollläden . add ( rollladenWohnzimmer2 );
        rollladenWohnzimmer2 . BeobachterRegistrieren ( rollladenSymbolWohnzimmer2 );
        oberfläche . SmartKomponenteHinzufügen ( rollladenWohnzimmer2 . NameGeben ( ) , rollladenWohnzimmer2 . ZustandGeben ( ) , rollladenWohnzimmer2 );
        wohnzimmer2 . KomponenteEintragen ( rollladenWohnzimmer2 );
        rollladenSymbolEsszimmer = new RollladenSymbol ( 500 , 325 );
        rollladenEsszimmer = new Rollladen ( "Esszimmer" , windsensorHaus , uhrHaus );
        rollläden . add ( rollladenEsszimmer );
        rollladenEsszimmer . BeobachterRegistrieren ( rollladenSymbolEsszimmer );
        oberfläche . SmartKomponenteHinzufügen ( rollladenEsszimmer . NameGeben ( ) , rollladenEsszimmer . ZustandGeben ( ) , rollladenEsszimmer );
        esszimmer . KomponenteEintragen ( rollladenEsszimmer );
        rollladenSymbolKüche = new RollladenSymbol ( 250 , 325 );
        rollladenKüche = new Rollladen ( "Küche" , windsensorHaus , uhrHaus );
        rollläden . add ( rollladenKüche );
        rollladenKüche . BeobachterRegistrieren ( rollladenSymbolKüche );
        oberfläche . SmartKomponenteHinzufügen ( rollladenKüche . NameGeben ( ) , rollladenKüche . ZustandGeben ( ) , rollladenKüche );
        küche . KomponenteEintragen ( rollladenKüche );
        sonnensensorWohnzimmer2 = new Sonnensensor ( "Wohnzimmer2" );
        wohnzimmer2 . KomponenteEintragen ( sonnensensorWohnzimmer2 );
        oberfläche . SmartKomponenteHinzufügen ( sonnensensorWohnzimmer2 . NameGeben ( ) , sonnensensorWohnzimmer2 . ZustandGeben ( ) , sonnensensorWohnzimmer2 );
        bewegungsmelderWohnzimmer2 = new Bewegungsmelder ( "Wohnzimmer2" );
        wohnzimmer2 . KomponenteEintragen ( bewegungsmelderWohnzimmer2 );
        oberfläche . SmartKomponenteHinzufügen ( bewegungsmelderWohnzimmer2 . NameGeben ( ) , bewegungsmelderWohnzimmer2 . ZustandGeben ( ) , bewegungsmelderWohnzimmer2 );
        lampenSymbolWohnzimmer2_1 = new LampenSymbol ( 450 , 105 );
        lampeWohnzimmer2_1 = new Lampe ( "Wohnzimmer2 1" , bewegungsmelderWohnzimmer2 , sonnensensorWohnzimmer2 );
        wohnzimmer2 . KomponenteEintragen ( lampeWohnzimmer2_1 );
        lampeWohnzimmer2_1 . BeobachterRegistrieren ( lampenSymbolWohnzimmer2_1 );
        oberfläche . SmartKomponenteHinzufügen ( lampeWohnzimmer2_1 . NameGeben ( ) , lampeWohnzimmer2_1 . ZustandGeben ( ) , lampeWohnzimmer2_1 );
        lampenSymbolWohnzimmer2_2 = new LampenSymbol ( 550 , 105 );
        lampeWohnzimmer2_2 = new Lampe ( "Wohnzimmer2 2" , bewegungsmelderWohnzimmer2 , sonnensensorWohnzimmer2 );
        wohnzimmer2 . KomponenteEintragen ( lampeWohnzimmer2_2 );
        lampeWohnzimmer2_2 . BeobachterRegistrieren ( lampenSymbolWohnzimmer2_2 );
        oberfläche . SmartKomponenteHinzufügen ( lampeWohnzimmer2_2 . NameGeben ( ) , lampeWohnzimmer2_2 . ZustandGeben ( ) , lampeWohnzimmer2_2 );
        waageKüche = new Waage ( "Küche" );
        küche . KomponenteEintragen ( waageKüche );
        oberfläche . SmartKomponenteHinzufügen ( waageKüche . NameGeben ( ) , waageKüche . ZustandGeben ( ) , waageKüche );
        kühlschrankSymbolKüche = new KuehlschrankSymbol ( 158 , 370 );
        kühlschrankKüche = new Kuehlschrank ( "Küche" , waageKüche );
        küche . KomponenteEintragen ( kühlschrankKüche );
        kühlschrankKüche . BeobachterRegistrieren ( kühlschrankSymbolKüche );
        oberfläche . SmartKomponenteHinzufügen ( kühlschrankKüche . NameGeben ( ) , kühlschrankKüche . ZustandGeben ( ) , kühlschrankKüche );
        oberfläche . Anzeigen ( );
    }

    /**
     * Schaltet alle Lampen dauerhaft ein
     */
    protected void LampenEinschalten()
    {
        wohnzimmer2 . GeräteEinschalten ( );
    }

    /**
     * Schaltet alle Lampen dauerhaft aus
     */
    protected void LampenAusschalten()
    {
        wohnzimmer2 . GeräteAusschalten ( );
    }

    /**
     * Setzt alle Lampen auf Automatikbetrieb
     */
    protected void LampenAutomatikSetzen()
    {
        wohnzimmer2 . GeräteAutomatikSetzen ( );
    }

    /**
     * Zieht alle Rollläden dauerhaft hoch
     */
    protected void RollladenHochziehen()
    {
        for (final Rollladen r : rollläden) {
            r . Ausschalten ( );
        }
    }

    /**
     * Lässt alle Rollläden dauerhaft runter
     */
    protected void RollladenRunterlassen()
    {
        for (final Rollladen r : rollläden) {
            r . Einschalten ( );
        }
    }

    /**
     * Setzt alle Rollläden auf Automatikbetrieb
     */
    protected void RollladenAutomatikSetzen()
    {
        for (final Rollladen r : rollläden) {
            r . AutomatikAktivieren ( );
        }
    }

    /**
     * Zeigt die zustände aller Geräte an
     */
    protected void ZuständeAnzeigen()
    {
        for (final ZimmerVerwaltung z : zimmer) {
            z . ZuständeAnzeigen ( );
        }
    }
}
