// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt einen Heizkörper
 * @author Albert Wiedemann @version 1.0
 */
public class Heizkoerper extends Hausgeraet
{
    /* Zustand des Heizkörpers*/
    private boolean an;
    /* Wert des Thermometers*/
    private int temperatur;

    /**
     * Legt den Namen und das Darstellungssymbol fest @param namensZusatz individualler Namensteil der Komponente @param t Thermometer
     */
    protected Heizkoerper(String namensZusatz, Thermometer t)
    {
        super("Heizkörper " + namensZusatz);
        temperatur = 0;
        an = true;
        automatik = true;
        t.BeobachterRegistrieren(this);
    }

    /**
     * Wird vom Thermometer bei einer neuen Temperatur aufgerufen @param wert die neue Temperatur
     */
    protected void WertänderungMelden(int wert, Messgeraet wer)
    {
        temperatur = wert;
        if (automatik) {
            an = temperatur < 22;
            ZustandsÄnderungMelden();
        }
    }

    /**
     * Meldet den Zustand der Komponente @return Zustand als Zeichenkette
     */
    protected String ZustandGeben()
    {
        if (an) {
            return "ein";
        }
        else {
            return "aus";
        }
    }

    /**
     * Schaltet die Komponente dauerhaft ein
     */
    public void Einschalten()
    {
        an = true;
        automatik = false;
        ZustandsÄnderungMelden();
    }

    /**
     * Schaltet die Komponente dauerhaft aus
     */
    public void Ausschalten()
    {
        an = false;
        automatik = false;
        ZustandsÄnderungMelden();
    }

    /**
     * Schaltet die Komponente auf Automatikbetrieb
     */
    public void AutomatikAktivieren()
    {
        an = temperatur < 22;
        automatik = true;
        ZustandsÄnderungMelden();
    }
}
