import lang.stride.*;
import java.util.ArrayList;

/**
 * Beschreibt die allgemeinen Teile eines Messgeräts
 * @author Albert Wiedemann @version 1.0
 */
public abstract class Messgeraet extends Smartkomponente implements WertEmpfaenger
{
    /* Messwertbeobachter dieses Messgeräts*/
    private ArrayList<Hausgeraet> beobachter;

    /**
     * Richtet das Beobachterfeld ein @param name der Gerätename
     */
    protected Messgeraet(String name)
    {
        super(name);
        beobachter =  new  ArrayList < Hausgeraet > ();
    }

    /**
     * Registriert einen Beobachter @param beobachter wird von jeder Wertänderung benachrichtigt
     */
    protected void BeobachterRegistrieren(Hausgeraet neuerBeobachter)
    {
        beobachter.add(neuerBeobachter);
    }

    /**
     * Meldet den neuen Wert an alle Beobachter @wert der zu meldende Wert
     */
    protected void MesswertÄnderungMelden(int wert)
    {
        for (final Hausgeraet k : beobachter) {
            k.WertänderungMelden(wert, this);
        }
    }

    /**
     * Meldet den neuen Wert an alle Beobachter @wert der zu meldende Wert
     */
    protected void MesswertÄnderungMelden(boolean wert)
    {
        for (final Hausgeraet k : beobachter) {
            k.WertänderungMelden(wert, this);
        }
    }

    /**
     * Prüft, ob die Eingabe akzeptiert werden kann @param eingabe der eventuelle neue Sensorwert @return wahr, wenn die Eingabe eine korrekten Sensorwert repräsentiert
     */
    public abstract boolean EingabePrüfen(String eingabe);

    /**
     * Setzt den neuen Sensorwert @param eingabe der neue Sensorwert
     */
    public abstract void WertSetzen(String eingabe);
}
