// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt einen Rollladen
 * @author Albert Wiedemann @version 1.0
 */
public class Rollladen extends Hausgeraet
{
    /* Zustand des Rollladens*/
    private boolean oben;
    /* Wert des Windsensors*/
    private int windwert;
    /* Wert der Uhr*/
    private int uhrzeit;
    /* der Windsensor*/
    protected Windsensor w;
    /* die Uhr*/
    protected Uhr u;

    /**
     * Legt den Namen und das Darstellungssymbol fest @param namensZusatz individualler Namensteil der Komponente @param w Windsensor @param u Uhr
     */
    protected Rollladen(String namensZusatz, Windsensor w, Uhr u)
    {
        super("Rollladen " + namensZusatz);
        oben = false;
        automatik = true;
        w.BeobachterRegistrieren(this);
        u.BeobachterRegistrieren(this);
        this.u = u;
        this.w = w;
    }

    /**
     * Wird vom Windsensor bei einer neuen Windstärke oder von der Uhr bei einer neuen Uhrzeit aufgerufen @param wert der neue Wert @param wer das aufrufende Messgerät
     */
    protected void WertänderungMelden(int wert, Messgeraet wer)
    {
        if (wer == w) {
            windwert = wert;
            if (automatik) {
                oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000);
                ZustandsÄnderungMelden();
            }
        }
        else if (wer == u) {
            uhrzeit = wert;
            if (automatik) {
                oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000);
                ZustandsÄnderungMelden();
            }
        }
    }

    /**
     * Meldet den Zustand der Komponente @return Zustand als Zeichenkette
     */
    protected String ZustandGeben()
    {
        if (oben) {
            return "offen";
        }
        else {
            return "geschlossen";
        }
    }

    /**
     * Zieht den Rollladen dauerhaft hoch
     */
    public void Ausschalten()
    {
        super.Ausschalten();
        oben = true;
        ZustandsÄnderungMelden();
    }

    /**
     * lässt den Rollladen dauerhaft runter
     */
    public void Einschalten()
    {
        super.Einschalten();
        oben = false;
        ZustandsÄnderungMelden();
    }

    /**
     * Schaltet die Komponente auf Automatikbetrieb
     */
    public void AutomatikAktivieren()
    {
        super.AutomatikAktivieren();
        oben = (windwert > 6) || (uhrzeit > 60000) && (uhrzeit < 200000);
        ZustandsÄnderungMelden();
    }
}
