// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt eine Uhr
 * @author Albert Wiedemann @version 1.0
 */
public class Uhr extends Messgeraet
{
    /* aktueller Wert der Zeit, Stunden*/
    private int stunden;
    /* aktueller Wert der Zeit, minuten*/
    private int minuten;
    /* aktueller Wert der Zeit, Sekunden*/
    private int sekunden;

    /**
     * Legt den Namen und den Beobachter fest. @param namensZusatz individualler Namensteil des Sensors
     */
    protected Uhr(String namensZusatz)
    {
        super("Uhr" + namensZusatz);
        stunden = 0;
        minuten = 0;
        sekunden = 0;
    }

    /**
     * Zerlegt den Eingabestring in seine Zeitbestandteile und setzt gegebenenfalls die aktuelle Zeit @param eingabe die zu testende Eingabe @param setzen bei wahr wird der eingegebene Wert gesetzt @return wahr, wenn die Eingabe eine korrekten Sensorwert repräsentiert
     */
    private boolean Zerlegen(String eingabe, boolean setzen)
    {
        try {
            String[] teile = eingabe.split(":");
            int s = 0;
            int m = 0;
            int h = 0;
            if (teile.length == 1) {
                h = Integer.parseUnsignedInt(teile[0]);
            }
            else if (teile.length == 2) {
                h = Integer.parseUnsignedInt(teile[0]);
                m = Integer.parseUnsignedInt(teile[1]);
            }
            else if (teile.length == 3) {
                h = Integer.parseUnsignedInt(teile[0]);
                m = Integer.parseUnsignedInt(teile[1]);
                s = Integer.parseUnsignedInt(teile[3]);
            }
            else {
                return false;
            }
            if ((s < 60) && (m < 60) && (h < 24)) {
                if (setzen) {
                    stunden = h;
                    minuten = m;
                    sekunden = s;
                }
                return true;
            }
            else {
                return false;
            }
        }
        catch (Exception e) {
            return false;
        }
    }

    /**
     * Prüft, ob die Eingabe akzeptiert werden kann @param eingabe der eventuelle neue Sensorwert @return wahr, wenn die Eingabe eine korrekten Sensorwert repräsentiert
     */
    public boolean EingabePrüfen(String eingabe)
    {
        return Zerlegen(eingabe, false);
    }

    /**
     * Setzt den neuen Sensorwert @param stunden der neue Wert für die Stunde
     */
    public void WertSetzen(String eingabe)
    {
        if (Zerlegen(eingabe, true)) {
            MesswertÄnderungMelden(stunden * 10000 + minuten * 100 + sekunden);
            ZustandsÄnderungMelden();
        }
    }

    /**
     * Konvertiert die Zahl in eine Zeichenkette mit (mindestens) zwei Stellen @param zahl die zu konvertierende Zahl @returns die zugehörige Zeichenkette
     */
    protected String ZahlNachString(int zahl)
    {
        if (zahl < 10) {
            return "0" + zahl;
        }
        else {
            return "" + zahl;
        }
    }

    /**
     * Meldet den Zustand der Uhr @return Zustand als Zeichenkette
     */
    protected String ZustandGeben()
    {
        return "" + stunden + ":" + ZahlNachString(minuten) + ":" + ZahlNachString(sekunden) + "Uhr";
    }
}
