// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt eine Waage
 * @author Albert Wiedemann @version 1.0
 */
public class Waage extends Messgeraet
{
    /* aktueller Wert der Messung*/
    private int aktuellerWert;

    /**
     * Legt den Namen und den Beobachter fest. @param namensZusatz individualler Namensteil des Sensors
     */
    protected Waage(String namensZusatz)
    {
        super("Waage " + namensZusatz);
        aktuellerWert = 0;
    }

    /**
     * Prüft, ob die Eingabe akzeptiert werden kann @param eingabe der eventuelle neue Sensorwert @return wahr, wenn die Eingabe eine korrekten Sensorwert repräsentiert
     */
    public boolean EingabePrüfen(String eingabe)
    {
        try {
            int wert = Integer . parseUnsignedInt ( eingabe );
            return wert <= 10000;
        }
        catch (Exception e) {
            return false;
        }
    }

    /**
     * Setzt den neuen Sensorwert @param eingabe der neue Sensorwert
     */
    public void WertSetzen(String eingabe)
    {
        int wert = Integer . parseUnsignedInt ( eingabe );
        if (aktuellerWert != wert) {
            aktuellerWert = wert;
            MesswertÄnderungMelden ( aktuellerWert );
            ZustandsÄnderungMelden ( );
        }
    }

    /**
     * Meldet den Zustand des Sensors @return Zustand als Zeichenkette
     */
    protected String ZustandGeben()
    {
        return "" + aktuellerWert + " g";
    }
}
