// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Eine Ampel verwendet zur Anzeige drei Lampen. Die Ampel verwaltet ihre Position als Ganzes, ihre Ausrichtung und auch die nach den Verkehrsregeln möglichen Ampelphasen.
 * @author Albert Wiedemann @version 1.0
 */
public class Ampel
{
    /* Der Bezugspunkt für die Position ist die obere linke Ecke der lampeOben.*/
    private int positionX;
    /* Der Bezugspunkt für die Position ist die obere linke Ecke der lampeOben.*/
    private int positionY;
    /* Mögliche Werte sind die in Deutschland erlaubten Ampelphasen grün, gelb, rot und rotgelb.*/
    private String ampelphase;
    /* Eine Ausrichtung ist in die vier Himmelsrichtungen N, W, S, O möglich.*/
    private char ausrichtung;
    /* Referenzattribute*/
    private Lampe lampeOben;
    private Lampe lampeMitte;
    private Lampe lampeUnten;

    /**
     * Der Konstruktor erzeugt eine Ampel an Position 1|1 mit Ausrichtung Süden in Phase rot.
     */
    protected Ampel()
    {
        positionX = 1;
        positionY = 1;
        ampelphase = "rot";
        ausrichtung = 'S';
        lampeOben = new Lampe ( );
        lampeMitte = new Lampe ( );
        lampeUnten = new Lampe ( );
        lampeOben . FarbeSetzen ( "rot" );
        lampeMitte . FarbeSetzen ( "schwarz" );
        lampeUnten . FarbeSetzen ( "schwarz" );
        AmpelAnordnen ( );
    }

    /**
     * Konstruktor für Objekte der Klasse Ampel mit folgenden Eingabewerten. @param positionXNeu - neue x-Position @param positionYNeu - neue y-Position @param ausrichtungNeu - neue Ausrichtung
     */
    protected Ampel(int positionXNeu, int positionYNeu, char ausrichtungNeu)
    {
        lampeOben = new Lampe ( );
        lampeMitte = new Lampe ( );
        lampeUnten = new Lampe ( );
        lampeOben . FarbeSetzen ( "rot" );
        lampeMitte . FarbeSetzen ( "schwarz" );
        lampeUnten . FarbeSetzen ( "schwarz" );
        PositionSetzen ( positionXNeu , positionYNeu );
        ampelphase = "rot";
        AusrichtungSetzen ( ausrichtungNeu );
    }

    /**
     * Setzt die Ampel auf grün.
     */
    protected void GrünSetzen()
    {
        ampelphase = "grün";
        lampeOben . FarbeSetzen ( "schwarz" );
        lampeMitte . FarbeSetzen ( "schwarz" );
        lampeUnten . FarbeSetzen ( "grün" );
    }

    /**
     * Setzt die Ampel auf gelb.
     */
    protected void GelbSetzen()
    {
        ampelphase = "gelb";
        lampeOben . FarbeSetzen ( "schwarz" );
        lampeMitte . FarbeSetzen ( "gelb" );
        lampeUnten . FarbeSetzen ( "schwarz" );
    }

    /**
     * Setzt die Ampel auf rot-gelb.
     */
    protected void RotgelbSetzen()
    {
        ampelphase = "rotgelb";
        lampeOben . FarbeSetzen ( "rot" );
        lampeMitte . FarbeSetzen ( "gelb" );
        lampeUnten . FarbeSetzen ( "schwarz" );
    }

    /**
     * Setzt die Ampel auf rot.
     */
    protected void RotSetzen()
    {
        ampelphase = "rot";
        lampeOben . FarbeSetzen ( "rot" );
        lampeMitte . FarbeSetzen ( "schwarz" );
        lampeUnten . FarbeSetzen ( "schwarz" );
    }

    /**
     * Schaltet die Ampelphasen in der Reihenfolge rot, rotgelb, grün, gelb
     */
    protected void Weiterschalten()
    {
        if (ampelphase == "rot") {
            RotgelbSetzen ( );
        }
        else {
            if (ampelphase == "rotgelb") {
                GrünSetzen ( );
            }
            else {
                if (ampelphase == "grün") {
                    GelbSetzen ( );
                }
                else {
                    RotSetzen ( );
                }
            }
        }
    }

    /**
     * Setzt die Ausrichtung der Ampel auf die möglichen Werte S, W, N, O. @param ausrichtungNeu neue Ausrichtung der Ampel
     */
    protected void AusrichtungSetzen(char ausrichtungNeu)
    {
        switch (ausrichtungNeu) {
            case 'S' : {
            }
            case 'W' : {
            }
            case 'N' : {
            }
            case 'O' : {
                ausrichtung = ausrichtungNeu;
                break;
            }
        }
        AmpelAnordnen ( );
    }

    /**
     * Setzt die Position der Ampel. Der Ursprung liegt in der Mitte des Fensters, die y-Achse zeigt nach unten.(x /y) bedeutet das Kästchen rechts unterhalb der Gitterlinien. @param x positionXNeu-Position @param y positionYNeu-Position
     */
    protected void PositionSetzen(int positionXNeu, int positionYNeu)
    {
        if (positionXNeu <= 7 && positionXNeu >= - 8 && positionYNeu <= 7 && positionYNeu >= - 8) {
            positionX = positionXNeu;
            positionY = positionYNeu;
            AmpelAnordnen ( );
        }
    }

    /**
     * Zeichnet die Ampel im Raster.
     */
    private void AmpelAnordnen()
    {
        switch (ausrichtung) {
            case 'S' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeMitte . PositionSetzen ( positionX , positionY + 1 );
                lampeUnten . PositionSetzen ( positionX , positionY + 2 );
                break;
            }
            case 'W' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeMitte . PositionSetzen ( positionX - 1 , positionY );
                lampeUnten . PositionSetzen ( positionX - 2 , positionY );
                break;
            }
            case 'N' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeMitte . PositionSetzen ( positionX , positionY - 1 );
                lampeUnten . PositionSetzen ( positionX , positionY - 2 );
                break;
            }
            case 'O' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeMitte . PositionSetzen ( positionX + 1 , positionY );
                lampeUnten . PositionSetzen ( positionX + 2 , positionY );
                break;
            }
        }
    }

    /**
     * Meldet, ob die Ampel auf grün steht. @return true, falls die Ampel grün zeigt.
     */
    protected boolean IstGrün()
    {
        return ampelphase == "grün";
    }

    /**
     * Meldet, ob die Ampel auf gelb steht. @return true, falls die Ampel gelb zeigt.
     */
    protected boolean IstGelb()
    {
        return ampelphase == "gelb";
    }
}
