// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Beschreibt ein allgemeines Fahrzeug.
 * @author Albert Wiedemann @version V1.0
 */
public abstract class Fahrzeug
{
    protected FahrzeugSymbol symbol;
    protected float x;
    protected float y;
    protected float v;
    protected float vmax;
    protected char ausrichtung;

    /**
     * Erzeugt die Anzeige.
     */
    protected Fahrzeug()
    {
        symbol = null;
        vmax = 13.89f;
        v = vmax;
        ausrichtung = 'O';
        x = 0;
        y = 0;
    }

    /**
     * Setzt die Position des Fahrzeugs.
     * @param x x-Position @param y y-Position
     */
    protected void PositionSetzen(float x, float y)
    {
        this . x = x;
        this . y = y;
        symbol . PositionSetzen ( x , y );
    }

    /**
     * Setzt die Ausrichtung des Fahrzeugs.
     * @param ausrichtung neue Ausrichtung
     */
    protected void AusrichtungSetzen(char ausrichtung)
    {
        this . ausrichtung = ausrichtung;
        symbol . AusrichtungSetzen ( ausrichtung );
    }

    /**
     * Fährt das Fahrzeug eine Sekunde nach rechts. @param wegmax maximaler Weg bis zum nächsten Hindernis @param vvorg Geschwindigkeit des Vorgängerfahrzeugs bzw.der Ampel
     */
    abstract void Fahren(float wegmax, float vvorg);

    /**
     * Meldet die x-Koordinate zurück @return x-Koordinate
     */
    protected float XKoordinateGeben()
    {
        return x;
    }

    /**
     * Meldet die y-Koordinate zurück @return y-Koordinate
     */
    protected float YKoordinateGeben()
    {
        return y;
    }

    /**
     * Meldet die Länge des Fahrzeugs zurück @return Länge
     */
    abstract float LängeGeben();

    /**
     * Meldet die Geschwindigkeit zurück @return Geschwindigkeit
     */
    protected float GeschwindigkeitGeben()
    {
        return v;
    }

    /**
     * Entfernt das Fahrzeug aus der Anzeige
     */
    protected void Entfernen()
    {
        symbol . Entfernen ( );
    }

    /* Erzeugt eine zufällige Farbe für das Fahrzeug @return legale Farbe*/

    /**
     * 
     */
    protected String FahrzeugFarbeErzeugen()
    {
        switch (( new java . util . Random ( ) ) . nextInt ( 7 )) {
            case 0 : {
                return "rot";
            }
            case 1 : {
                return "grün";
            }
            case 2 : {
                return "blau";
            }
            case 3 : {
                return "gelb";
            }
            case 4 : {
                return "cyan";
            }
            case 5 : {
                return "magenta";
            }
            case 6 : {
                return "weiss";
            }
            default : {
                return "schwarz";
            }
        }
    }

    /**
     * Erzeugt ein neues Fahrzeug. Mögliche Werte für den Parameter sind:<br> pkw: Standardpkw<br> lkw: Lkw<br> sportwagen: Sportwagen<br> lkwmitanhänger: Lkw mit Anhänger @param art Art des zu erzeugenden Fahrzeugs
     */
    static protected Fahrzeug FahrzeugErzeugen(String art)
    {
        if (art == "pkw") {
            return new PKW ( );
        }
        else if (art == "lkw") {
            return new LKW ( );
        }
        else if (art == "sportwagen") {
            return new Sportwagen ( );
        }
        else if (art == "lkwmitanhänger") {
            return new LKWMitAnhaenger ( );
        }
        else {
            return null;
        }
    }
}
