// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Eine Fußgängerampel verwendet zur Anzeige zwei Lampen. Die Fußgängerampel verwaltet ihre Position als Ganzes, ihre Ausrichtung und auch die nach den Verkehrsregeln möglichen Ampelphasen.
 * @author Albert Wiedemann @version 1.0
 */
public class FussgaengerAmpel
{
    /* Der Bezugspunkt für die Position ist die obere linke Ecke der lampeOben.*/
    private int positionX;
    /* Der Bezugspunkt für die Position ist die obere linke Ecke der lampeOben.*/
    private int positionY;
    /* Mögliche Werte sind die in Deutschland erlaubten Ampelphasen grün, gelb, rot und rotgelb.*/
    private String ampelphase;
    /* Eine Ausrichtung ist in die vier Himmelsrichtungen N, W, S, O möglich.*/
    private char ausrichtung;
    /* Referenzattribute*/
    private Lampe lampeOben;
    private Lampe lampeUnten;

    /**
     * Der Konstruktor erzeugt eine Fußgängerampel an Position 1|1 mit Ausrichtung Süden in Phase grün.
     */
    protected FussgaengerAmpel()
    {
        positionX = 1;
        positionY = 1;
        ampelphase = "rot";
        ausrichtung = 'S';
        lampeOben = new Lampe ( );
        lampeUnten = new Lampe ( );
        lampeOben . FarbeSetzen ( "rot" );
        lampeUnten . FarbeSetzen ( "schwarz" );
        AmpelAnordnen ( );
    }

    /**
     * Konstruktor für Objekte der Klasse FußgängerAmpel mit folgenden Eingabewerten. @param positionXNeu - neue x-Position @param positionYNeu - neue y-Position @param ausrichtungNeu - neue Ausrichtung
     */
    protected FussgaengerAmpel(int positionXNeu, int positionYNeu, char ausrichtungNeu)
    {
        lampeOben = new Lampe ( );
        lampeUnten = new Lampe ( );
        lampeOben . FarbeSetzen ( "rot" );
        lampeUnten . FarbeSetzen ( "schwarz" );
        PositionSetzen ( positionXNeu , positionYNeu );
        ampelphase = "rot";
        AusrichtungSetzen ( ausrichtungNeu );
    }

    /**
     * Setzt die Fussgängerampel auf grün.
     */
    protected void GrünSetzen()
    {
        ampelphase = "grün";
        lampeOben . FarbeSetzen ( "schwarz" );
        lampeUnten . FarbeSetzen ( "grün" );
    }

    /**
     * Setzt die Fussgängerampel auf rot.
     */
    protected void RotSetzen()
    {
        ampelphase = "rot";
        lampeOben . FarbeSetzen ( "rot" );
        lampeUnten . FarbeSetzen ( "schwarz" );
    }

    /**
     * Schaltet die Ampelphasen in der Reihenfolge von rot auf grün bzw.umgekehrt
     */
    protected void Weiterschalten()
    {
        if (ampelphase == "rot") {
            GrünSetzen ( );
        }
        else {
            RotSetzen ( );
        }
    }

    /**
     * Setzt die Ausrichtung der Fussgängerampel auf die möglichen Werte S, W, N, O. @param ausrichtungNeu neue Ausrichtung der Ampel
     */
    protected void AusrichtungSetzen(char ausrichtungNeu)
    {
        switch (ausrichtungNeu) {
            case 'S' : {
            }
            case 'W' : {
            }
            case 'N' : {
            }
            case 'O' : {
                ausrichtung = ausrichtungNeu;
                break;
            }
        }
        AmpelAnordnen ( );
    }

    /**
     * Setzt die Position der Fussgängerampel. Der Ursprung liegt in der Mitte des Fensters, die y-Achse zeigt nach unten.(x /y) bedeutet das Kästchen rechts unterhalb der Gitterlinien. @param x positionXNeu-Position @param y positionYNeu-Position
     */
    protected void PositionSetzen(int positionXNeu, int positionYNeu)
    {
        if (positionXNeu <= 7 && positionXNeu >= - 8 && positionYNeu <= 7 && positionYNeu >= - 8) {
            positionX = positionXNeu;
            positionY = positionYNeu;
            AmpelAnordnen ( );
        }
    }

    /**
     * Zeichnet die Fussgängerampel im Raster.
     */
    private void AmpelAnordnen()
    {
        switch (ausrichtung) {
            case 'S' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeUnten . PositionSetzen ( positionX , positionY + 1 );
                break;
            }
            case 'W' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeUnten . PositionSetzen ( positionX - 1 , positionY );
                break;
            }
            case 'N' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeUnten . PositionSetzen ( positionX , positionY - 1 );
                break;
            }
            case 'O' : {
                lampeOben . PositionSetzen ( positionX , positionY );
                lampeUnten . PositionSetzen ( positionX + 1 , positionY );
                break;
            }
        }
    }
}
