
/**
 * Leitet die Eingabeereignisse der Oberfläche an die entsprechenden Objete weiter
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class Kontrolleur implements KontrolleurInterface
{
    /** Die Kreuzung */
    private Kreuzung k;
    /** Der Taktgeber */
    private TaktGeber t;

    /**
     * Legt die Zielobjekte fest
     * @param k Die Kreuzung
     * @param t Der TaktGeber
     */
    Kontrolleur(Kreuzung k, TaktGeber t)
    {
        this.k = k;
        this.t = t;
    }

    /**
     * Setzt die mittlere Wartezeit zwischen 2 Fahrzeugen
     * @param zeit mittlere Wartezeit
     */
    public void FahrzeugabstandSetzen(int zeit)
    {
        k.FahrzeugabstandSetzen(zeit);
    }

    /**
     * Taktgeber starten
     */
    public void Starten()
    {
        t.Starten();
    }

    /**
     * Taktgeber anhalten
     */
    public void Anhalten()
    {
        t.Anhalten();
    }
    
    /**
     * Ablaufgeschwindigkeit einstellen
     * @param dauer Angabe in Millisekunden
     */
    public void TaktdauerSetzen(int dauer)
    {
        t.TaktdauerSetzen(dauer);
    }
}
