// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.Random;
import java.util.ArrayList;

/**
 * Die Klasse Kreuzung beschreibt eine Kreuzung, die aus vier Kfz- und acht Fussgängerampeln besteht.Alle Ampeln sind um den Koordinatenursprung positioniert.Die Lichtsignale können verschiedene Phasen durchlaufen, wobei mit der Grünphase in Ost/West Richtung und gleichzeitig der Rotphase in Nord/Süd Richtung begonnen wird.
 * 
 * @author Albert Wiedemann @version  1.0
 */
public class Kreuzung implements TaktKlient
{
    /* Das Attribut Phase beschreibt welche Verkehrsströme innerhalb der Ampel freigegeben bzw.gesperrt sind; nur die Werte 1 bis 8 sind erlaubt. <BR>1:                    in Ost/West Richtung: KfZ: grün  | Fussgänger grün <BR>       in Nord/Süd Richtung: KfZ: rot  | Fussgänger rot <BR> 2:                    in Ost/West Richtung: KfZ: grün  | Fussgänger rot <BR>       in Nord/Süd Richtung: KfZ: rot  | Fussgänger rot <BR> 3:                    in Ost/West Richtung: KfZ: gelb  | Fussgänger rot <BR>       in Nord/Süd Richtung: KfZ: rot  | Fussgänger rot <BR> 4:                    in Ost/West Richtung: KfZ: rot  | Fussgänger rot <BR>       in Nord/Süd Richtung: KfZ: rotgelb  | Fussgänger grün <BR> 5:                    in Ost/West Richtung: KfZ: rot  | Fussgänger rot <BR>       in Nord/Süd Richtung: KfZ: grün  | Fussgänger grün <BR> 6:                    in Ost/West Richtung: KfZ: rot  | Fussgänger rot <BR>       in Nord/Süd Richtung: KfZ: grün  | Fussgänger rot <BR> 7:                    in Ost/West Richtung: KfZ: rot  | Fussgänger rot <BR>       in Nord/Süd Richtung: KfZ: gelb  | Fussgänger rot <BR> 8:                    in Ost/West Richtung: KfZ: rotgelb  | Fussgänger grün <BR>       in Nord/Süd Richtung: KfZ: rot  | Fussgänger rot <BR>*/
    private int schaltphase;
    /* Zeitsteuerung für die Ampelschaltung*/
    private int wartezeitAmpel;
    private int wartezeitKurz;
    private int wartezeitLang;
    private int wartezeitFahrzeugNachOst;
    private int wartezeitFahrzeugNachWest;
    private int wartezeitFahrzeugNachNord;
    private int wartezeitFahrzeugNachSüd;
    private int mittlereWartezeit;
    private Random zzgenerator;
    /* Referenzattribute*/
    private Ampel ampelNord;
    private Ampel ampelOst;
    private Ampel ampelSüd;
    private Ampel ampelWest;
    private FussgaengerAmpel fgAmpelNord1;
    private FussgaengerAmpel fgAmpelNord2;
    private FussgaengerAmpel fgAmpelOst1;
    private FussgaengerAmpel fgAmpelOst2;
    private FussgaengerAmpel fgAmpelSüd1;
    private FussgaengerAmpel fgAmpelSüd2;
    private FussgaengerAmpel fgAmpelWest1;
    private FussgaengerAmpel fgAmpelWest2;
    private Fahrbahn nachOst;
    private Fahrbahn nachWest;
    private Fahrbahn nachNord;
    private Fahrbahn nachSüd;

    /**
     * Erzeugt die vier Ampeln, positioniert sie um den Ursprung und setzt die Lichtsignale so, dass eine Grünphase in Ost/West Richtung und gleichzeitig der Rotphase in Nord/Süd Richtung vorliegt.
     */
    protected Kreuzung()
    {
        schaltphase = 1;
        ampelNord = new Ampel ( - 2 , - 6 , 'N' );
        ampelNord . RotSetzen ( );
        fgAmpelNord1 = new FussgaengerAmpel ( - 4 , - 2 , 'N' );
        fgAmpelNord1 . RotSetzen ( );
        fgAmpelNord2 = new FussgaengerAmpel ( 3 , - 2 , 'N' );
        fgAmpelNord2 . RotSetzen ( );
        ampelOst = new Ampel ( 5 , - 2 , 'O' );
        ampelOst . GrünSetzen ( );
        fgAmpelOst1 = new FussgaengerAmpel ( 1 , - 4 , 'O' );
        fgAmpelOst1 . GrünSetzen ( );
        fgAmpelOst2 = new FussgaengerAmpel ( 1 , 3 , 'O' );
        fgAmpelOst2 . GrünSetzen ( );
        ampelSüd = new Ampel ( 1 , 5 , 'S' );
        ampelSüd . RotSetzen ( );
        fgAmpelSüd1 = new FussgaengerAmpel ( 3 , 1 , 'S' );
        fgAmpelSüd1 . RotSetzen ( );
        fgAmpelSüd2 = new FussgaengerAmpel ( - 4 , 1 , 'S' );
        fgAmpelSüd2 . RotSetzen ( );
        ampelWest = new Ampel ( - 6 , 1 , 'W' );
        ampelWest . GrünSetzen ( );
        fgAmpelWest1 = new FussgaengerAmpel ( - 2 , 3 , 'W' );
        fgAmpelWest1 . GrünSetzen ( );
        fgAmpelWest2 = new FussgaengerAmpel ( - 2 , - 4 , 'W' );
        fgAmpelWest2 . GrünSetzen ( );
        nachOst = new Fahrbahn ( ampelOst );
        nachOst . PositionSetzen ( 0 , 0 );
        nachOst . AusrichtungSetzen ( 'O' );
        nachWest = new Fahrbahn ( ampelWest );
        nachWest . PositionSetzen ( 0 , 0 );
        nachWest . AusrichtungSetzen ( 'W' );
        nachNord = new Fahrbahn ( ampelNord );
        nachNord . PositionSetzen ( 0 , 0 );
        nachNord . AusrichtungSetzen ( 'N' );
        nachSüd = new Fahrbahn ( ampelSüd );
        nachSüd . PositionSetzen ( 0 , 0 );
        nachSüd . AusrichtungSetzen ( 'S' );
        wartezeitKurz = 5;
        wartezeitLang = 30;
        wartezeitAmpel = 0;
        wartezeitFahrzeugNachOst = 0;
        wartezeitFahrzeugNachWest = 0;
        wartezeitFahrzeugNachNord = 0;
        wartezeitFahrzeugNachSüd = 0;
        mittlereWartezeit = 6;
        zzgenerator = ZufallsGenerator . Holen ( );
    }

    /**
     * Schaltet die Phase entprechend der beim Attribut Phase angegebenen Reihenfolge weiter.
     */
    protected void Weiterschalten()
    {
        switch (schaltphase) {
            case 1 : {
                fgAmpelWest1 . RotSetzen ( );
                fgAmpelWest2 . RotSetzen ( );
                fgAmpelOst1 . RotSetzen ( );
                fgAmpelOst2 . RotSetzen ( );
                schaltphase = 2;
                wartezeitAmpel = wartezeitLang;
                break;
            }
            case 2 : {
                ampelWest . GelbSetzen ( );
                ampelOst . GelbSetzen ( );
                schaltphase = 3;
                wartezeitAmpel = wartezeitKurz;
                break;
            }
            case 3 : {
                ampelWest . RotSetzen ( );
                ampelOst . RotSetzen ( );
                ampelNord . RotgelbSetzen ( );
                ampelSüd . RotgelbSetzen ( );
                fgAmpelNord1 . GrünSetzen ( );
                fgAmpelNord2 . GrünSetzen ( );
                fgAmpelSüd1 . GrünSetzen ( );
                fgAmpelSüd2 . GrünSetzen ( );
                schaltphase = 4;
                wartezeitAmpel = wartezeitKurz;
                break;
            }
            case 4 : {
                ampelNord . GrünSetzen ( );
                ampelSüd . GrünSetzen ( );
                schaltphase = 5;
                wartezeitAmpel = wartezeitLang;
                break;
            }
            case 5 : {
                fgAmpelNord1 . RotSetzen ( );
                fgAmpelNord2 . RotSetzen ( );
                fgAmpelSüd1 . RotSetzen ( );
                fgAmpelSüd2 . RotSetzen ( );
                schaltphase = 6;
                wartezeitAmpel = wartezeitLang;
                break;
            }
            case 6 : {
                ampelNord . GelbSetzen ( );
                ampelSüd . GelbSetzen ( );
                schaltphase = 7;
                wartezeitAmpel = wartezeitKurz;
                break;
            }
            case 7 : {
                ampelWest . RotgelbSetzen ( );
                ampelOst . RotgelbSetzen ( );
                ampelNord . RotSetzen ( );
                ampelSüd . RotSetzen ( );
                fgAmpelWest1 . GrünSetzen ( );
                fgAmpelWest2 . GrünSetzen ( );
                fgAmpelOst1 . GrünSetzen ( );
                fgAmpelOst2 . GrünSetzen ( );
                schaltphase = 8;
                wartezeitAmpel = wartezeitKurz;
                break;
            }
            case 8 : {
                ampelWest . GrünSetzen ( );
                ampelOst . GrünSetzen ( );
                schaltphase = 1;
                wartezeitAmpel = wartezeitLang;
                break;
            }
        }
    }

    /**
     * Erzeugt eine zufällige Wartezeit mit großer Wahrscheinlichkeit in der Mitte @return die erzeugte Wartezeit
     */
    private int WartezeitGenerieren()
    {
        float auswahl;
        auswahl = zzgenerator . nextFloat ( );
        if (auswahl < 0.1f) {
            return mittlereWartezeit - 2;
            /* 10% Wahrscheinlichkeit*/
        }
        else if (auswahl < 0.30f) {
            return mittlereWartezeit - 1;
            /* 20% Wahrscheinlichkeit*/
        }
        else if (auswahl < 0.70f) {
            return mittlereWartezeit;
            /* 40% Wahrscheinlichkeit*/
        }
        else if (auswahl < 0.90f) {
            return mittlereWartezeit + 1;
            /* 20% Wahrscheinlichkeit*/
        }
        else {
            return mittlereWartezeit + 2;
            /* 10% Wahrscheinlichkeit*/
        }
    }

    /**
     * Erzeugt ein neues Fahrzeug @return das neue Fahrzeug
     */
    protected Fahrzeug FahrzeugGenerieren()
    {
        switch (zzgenerator . nextInt ( 5 )) {
            case 0 : {
            }
            case 1 : {
                return Fahrzeug . FahrzeugErzeugen ( "pkw" );
            }
            case 2 : {
                return Fahrzeug . FahrzeugErzeugen ( "lkw" );
            }
            case 3 : {
                return Fahrzeug . FahrzeugErzeugen ( "sportwagen" );
            }
            case 4 : {
                return Fahrzeug . FahrzeugErzeugen ( "lkwmitanhänger" );
            }
            default : {
                return null;
            }
        }
    }

    /**
     * Empfängt die Impulse des Taktgebers Sie schaltet die Ampeln weiter und erzeugt und bewegt die Fahrzeuge.
     */
    public void TaktImpulsAusführen()
    {
        /* Ampeln weiterschalten*/
        if (wartezeitAmpel <= 0) {
            Weiterschalten ( );
        }
        else {
            wartezeitAmpel = wartezeitAmpel - 1;
        }
        /* Fahrzeuge bewegen*/
        nachOst . FahrzeugeBewegen ( );
        nachWest . FahrzeugeBewegen ( );
        nachSüd . FahrzeugeBewegen ( );
        nachNord . FahrzeugeBewegen ( );
        /* neue Fahrzeuge erzeugen*/
        if (wartezeitFahrzeugNachOst <= 0) {
            nachOst . FahrzeugEinreihen ( FahrzeugGenerieren ( ) );
            wartezeitFahrzeugNachOst = WartezeitGenerieren ( );
        }
        else {
            wartezeitFahrzeugNachOst = wartezeitFahrzeugNachOst - 1;
        }
        if (wartezeitFahrzeugNachWest <= 0) {
            nachWest . FahrzeugEinreihen ( FahrzeugGenerieren ( ) );
            wartezeitFahrzeugNachWest = WartezeitGenerieren ( );
        }
        else {
            wartezeitFahrzeugNachWest = wartezeitFahrzeugNachWest - 1;
        }
        if (wartezeitFahrzeugNachNord <= 0) {
            nachNord . FahrzeugEinreihen ( FahrzeugGenerieren ( ) );
            wartezeitFahrzeugNachNord = WartezeitGenerieren ( );
        }
        else {
            wartezeitFahrzeugNachNord = wartezeitFahrzeugNachNord - 1;
        }
        if (wartezeitFahrzeugNachSüd <= 0) {
            nachSüd . FahrzeugEinreihen ( FahrzeugGenerieren ( ) );
            wartezeitFahrzeugNachSüd = WartezeitGenerieren ( );
        }
        else {
            wartezeitFahrzeugNachSüd = wartezeitFahrzeugNachSüd - 1;
        }
    }

    /**
     * Setzt die mittlere Wartezeit zwischen 2 Fahrzeugen @param zeit mittlere Wartezeit
     */
    protected void FahrzeugabstandSetzen(int zeit)
    {
        mittlereWartezeit = zeit;
    }
}
