
/**
 * Ein Fahrzeugsymbol auf einem Fenster.
 * Das Fenster wird bei Bedarf generiert.
 *
 * @author Albert Wiedemann
 * @version 1.0
 */

import java.awt.*;

class LKWMitAnhaengerSymbol extends FahrzeugSymbol
{
    /**
     * Standardkonstruktor für Objekte der Klasse LKWMITANHANGERSYMBOL.
     * Er erzeugt ein blaues Symbol in der Mitte des Fensters,
     * Fahrtrichtung Osten.
     * Das Fenster wird bei Bedarf angelegt.
     */
    LKWMitAnhaengerSymbol ()
    {
        super ();
        länge = Oberflaeche.RasterGrößeGeben () * 3;
        anzeige = new Canvas () {

            /**
             * Stellt das Fahrzeug auf dem Fenster dar.
             */
            public void paint (Graphics g)
            {
                Polygon umriss = null;
                Polygon umriss2 = null;
                Polygon umriss3 = null;
                Polygon umriss4 = null;
                Polygon umriss5 = null;
                switch (ausrichtung)
                {
                    case 'S':
                        umriss = new Polygon (new int []{0, 0, 2, breite - 3, breite - 1, breite - 1}, new int [] {länge / 2, länge - 3, länge - 1, länge - 1, länge - 3, länge / 2}, 6);
                        umriss2 = new Polygon (new int []{1, 1, 3, breite - 4, breite - 2, breite - 2}, new int [] {länge / 2 + 1, länge - 3, länge - 2, länge - 2, länge - 3, länge / 2 + 1}, 6);
                        umriss3 = new Polygon (new int []{0, 0, breite - 1, breite - 1}, new int [] {0, länge / 2 - 3, länge / 2 - 3, 0}, 4);
                        umriss4 = new Polygon (new int []{1, 1, breite - 2, breite - 2}, new int [] {1, länge / 2 - 4, länge / 2 - 4, 1}, 4);
                        umriss5 = new Polygon (new int []{breite / 2 - 1, breite / 2 - 1, breite / 2, breite / 2}, new int [] {länge / 2, länge / 2 - 3, länge / 2 - 3, länge / 2}, 4);
                        break;
                    case 'N':
                        umriss = new Polygon (new int []{2, 0, 0, breite - 1, breite - 1, breite - 3}, new int [] {0, 3, länge / 2 - 1, länge / 2 - 1, 3, 0}, 6);
                        umriss2 = new Polygon (new int []{3, 1, 1, breite - 2, breite - 2, breite - 4}, new int [] {1, 4, länge / 2 - 2, länge / 2 - 2, 4, 1}, 6);
                        umriss3 = new Polygon (new int []{0, 0, breite - 1, breite - 1}, new int [] {länge / 2 + 3, länge - 1, länge - 1, länge / 2 + 3}, 4);
                        umriss4 = new Polygon (new int []{1, 1, breite - 2, breite - 2}, new int [] {länge / 2 + 4, länge - 2, länge - 2, länge / 2 + 4}, 4);
                        umriss5 = new Polygon (new int []{breite / 2 - 1, breite / 2 - 1, breite / 2, breite / 2}, new int [] {länge / 2, länge / 2 + 3, länge / 2 + 3, länge / 2}, 4);
                        break;
                    case 'O':
                        umriss = new Polygon (new int []{länge / 2, länge - 3, länge - 1, länge - 1, länge - 3, länge / 2}, new int [] {0, 0, 2, breite - 3, breite - 1, breite - 1}, 6);
                        umriss2 = new Polygon (new int []{länge / 2 + 1, länge - 3, länge - 2, länge - 2, länge - 3, länge / 2 + 1}, new int [] {1, 1, 3, breite - 4, breite - 2, breite - 2}, 6);
                        umriss3 = new Polygon (new int []{0, länge / 2 - 4, länge / 2 - 4, 0}, new int [] {0, 0, breite - 1, breite - 1}, 4);
                        umriss4 = new Polygon (new int []{1, länge / 2 - 5, länge / 2 - 5, 1}, new int [] {1, 1, breite - 2, breite - 2}, 4);
                        umriss5 = new Polygon (new int []{länge / 2, länge / 2 - 3, länge / 2 - 3, länge / 2}, new int [] {breite / 2 - 1, breite / 2 - 1, breite / 2, breite / 2}, 4);
                        break;
                    case 'W':
                        umriss = new Polygon (new int []{0, 4, länge / 2 - 1, länge / 2 - 1, 4, 0}, new int [] {2, 0, 0, breite - 1, breite - 1, breite - 3}, 6);
                        umriss2 = new Polygon (new int []{1, 4, länge / 2 - 2, länge / 2 - 2, 4, 1}, new int [] {3, 1, 1, breite - 2, breite - 2, breite - 4}, 6);
                        umriss3 = new Polygon (new int []{länge / 2 + 3, länge - 1, länge - 1, länge / 2 + 3}, new int [] {0, 0, breite - 1, breite - 1}, 4);
                        umriss4 = new Polygon (new int []{länge / 2 + 4, länge - 2, länge - 2, länge / 2 + 4}, new int [] {1, 1, breite - 2, breite - 2}, 4);
                        umriss5 = new Polygon (new int []{länge / 2, länge / 2 + 3, länge / 2 + 3, länge / 2}, new int [] {breite / 2 - 1, breite / 2 - 1, breite / 2, breite / 2}, 4);
                        break;
                }
                g.setColor (AWTFarbe (aktFarbe));
                g.fillPolygon (umriss);
                g.fillPolygon (umriss3);
                g.setColor (Color.black);
                g.drawPolygon (umriss);
                g.drawPolygon (umriss2);
                g.drawPolygon (umriss3);
                g.drawPolygon (umriss4);
                g.drawPolygon (umriss5);
            }

        };
        anzeige.setVisible (true);
        anzeige.setSize (länge + 1, breite + 1);
        fenster.add (anzeige, 0);
        PositionSetzen (0, 0);
    }
}
