
/**
 * Ein Fahrzeugsymbol auf einem Fenster.
 * Das Fenster wird bei Bedarf generiert.
 *
 * @author Albert Wiedemann
 * @version 1.0
 */

import java.awt.*;

class PKWSymbol extends FahrzeugSymbol
{
    /**
     * Standardkonstruktor für Objekte der Klasse PKWSYMBOL.
     * Er erzeugt ein blaues Symbol in der Mitte des Fensters,
     * Fahrtrichtung Osten.
     * Das Fenster wird bei Bedarf angelegt.
     */
    PKWSymbol ()
    {
        super ();
        länge = Oberflaeche.RasterGrößeGeben ();
        anzeige = new Canvas () {

            /**
             * Stellt das Fahrzeug auf dem Fenster dar.
             */
            public void paint (Graphics g)
            {
                Polygon umriss = null;
                Polygon umriss2 = null;
                switch (ausrichtung)
                {
                    case 'S':
                        g.clearRect (0, 0, breite, länge);
                        umriss = new Polygon (new int []{0, 0, 2, breite - 3, breite - 1, breite - 1}, new int [] {0, länge - 7, länge - 1, länge - 1, länge - 7, 0}, 6);
                        umriss2 = new Polygon (new int []{1, 1, 3, breite - 4, breite - 2, breite - 2}, new int [] {1, länge - 7, länge - 2, länge - 2, länge - 7, 1}, 6);
                        break;
                    case 'N':
                        g.clearRect (0, 0, breite, länge);
                        umriss = new Polygon (new int []{2, 0, 0, breite - 1, breite - 1, breite - 3}, new int [] {0, 7, länge - 1, länge - 1, 7, 0}, 6);
                        umriss2 = new Polygon (new int []{3, 1, 1, breite - 2, breite - 2, breite - 4}, new int [] {1, 7, länge - 2, länge - 2, 7, 1}, 6);
                        break;
                    case 'O':
                        g.clearRect (0, 0, länge, breite);
                        umriss = new Polygon (new int []{0, länge - 7, länge - 1, länge - 1, länge - 7, 0}, new int [] {0, 0, 2, breite - 3, breite - 1, breite - 1}, 6);
                        umriss2 = new Polygon (new int []{1, länge - 7, länge - 2, länge - 2, länge - 7, 1}, new int [] {1, 1, 3, breite - 4, breite - 2, breite - 2}, 6);
                        break;
                    case 'W':
                        g.clearRect (0, 0, länge, breite);
                        umriss = new Polygon (new int []{0, 7, länge - 1, länge - 1, 7, 0}, new int [] {2, 0, 0, breite - 1, breite - 1, breite - 3}, 6);
                        umriss2 = new Polygon (new int []{1, 7, länge - 2, länge - 2, 7, 1}, new int [] {3, 1, 1, breite - 2, breite - 2, breite - 4}, 6);
                        break;
                }
                g.setColor (AWTFarbe (aktFarbe));
                g.fillPolygon (umriss);
                g.setColor (Color.black);
                g.drawPolygon (umriss);
                g.drawPolygon (umriss2);
            }

        };
        anzeige.setVisible (true);
        anzeige.setSize (länge + 1, breite + 1);
        fenster.add (anzeige, 0);
        PositionSetzen (0, 0);
    }
}

