
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Knopf mit geteilten Schaltflächen
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class DoppelKnopf extends JComponent
{
    /** Maus gedrückt */
    private boolean gedrückt;
    /** Linke Seite invertieren */
    private boolean invertiert1;
    /** Rechte Seite Invertieren */
    private boolean invertiert2;
    /** x-Koordinate des Mausklicks */
    private int xKlick;
    
    /**
     * Der Konstruktor legt die Mausbehandlung an.
     */
    DoppelKnopf()
    {
        super();
        gedrückt = false;
        invertiert1 = false;
        invertiert2 = false;
        xKlick = -1;
        addMouseListener(new MouseAdapter ()
        {
            public void mousePressed (MouseEvent e)
            {
                requestFocusInWindow();
                gedrückt = true;
                xKlick = e.getX();
                repaint();
            }
            public void mouseReleased (MouseEvent e)
            {
                gedrückt = false;
                if ((e.getX() >= 0) && (e.getX() < getWidth()) && (e.getY() >= 0) && (e.getY() < getHeight()))
                {
                    if ((e.getX() <= getWidth() / 2) && (xKlick <= getWidth() / 2))
                    {
                        invertiert1 = !invertiert1;
                    }
                    if ((e.getX() > getWidth() / 2) && (xKlick > getWidth() / 2))
                    {
                        invertiert2 = !invertiert2;
                    }
                }
                repaint();
            }
        });
    }
    
    /**
     * Die Zeichenmethode zum Darstellen des Knopfes
     * @param g das Grafikobjekt
     */
    @Override public void paint (Graphics g)
    {
        int breite = getWidth();
        int höhe = getHeight();
        g.clearRect(0, 0, breite, höhe);
        g.setColor (invertiert1 ? Color. red: Color.green);
        g.fillRect(0, 0, breite / 2, höhe);
        g.setColor (invertiert2 ? Color. blue: Color.yellow);
        g.fillRect(breite / 2 + 1, 0, breite / 2, höhe);
        if (gedrückt)
        {
            g.setColor(new Color(0, 0, 0, 50));
            if (xKlick < breite / 2)
            {
                g.fillRect(0, 0, breite / 2, höhe);
            }
            else
            {
                g.fillRect(breite / 2 + 1, 0, breite / 2, höhe);
            }
        }
    }
}
