
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**
 * Eine einfache, selbst gezeichnete Figur
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class Knopf extends JComponent
{
    /** Wurde der Knopf gedrück */
    private boolean gedrückt;
    /** Beobachter für dei Knopfaktion */
    private KnopfBeobachter beobachter;
    
    /**
     * Der Konstruktor legt die Mausbehandlung an.
     * @param b der Beobachter für das Ausführen
     */
    Knopf(KnopfBeobachter b)
    {
        super();
        gedrückt = false;
        beobachter = b;
        addMouseListener(new MouseAdapter ()
        {
            public void mousePressed (MouseEvent e)
            {
                requestFocusInWindow();
                gedrückt = true;
                repaint();
            }
            public void mouseReleased (MouseEvent e)
            {
                gedrückt = false;
                repaint();
                if ((e.getX() >= 0) && (e.getX() < getWidth()) && (e.getY() >= 0) && (e.getY() < getHeight()))
                {
                    beobachter.Ausführen();
                }
            }
        });
    }
    
    /**
     * Die Zeichenmethode zum Darstellen des Knopfes
     * @param g das Grafikobjekt
     */
    @Override public void paint (Graphics g)
    {
        int breite = getWidth();
        int höhe = getHeight();
        g.clearRect(0, 0, breite, höhe);
        g.setColor (Color. blue);
        g.fillRoundRect(0, 0, breite, höhe, breite/5, höhe/5);
        g.setColor (gedrückt ? Color.gray : Color.lightGray);
        g.fillRoundRect(3, 3, breite-6, höhe-6, breite/5, höhe/5);

    }
}
